outlets = 2;

var bangA = 0;
		
function list()
{
	var a = arrayfromargs(arguments);
	var spkIdx = a[0]; // From speaker to start from, first spk is 0
	var nbSpks = a[1];
	var channel = a[2];
	var column = a[3];
	var speed = a[4];
	var direction = a[5];
    
	var forward = 1;
	var prevSpk = -1;
	var cnt = 0;

    // Clear
    for (var i = 0; i < nbSpks; i++){
        outlet (0, column + " " + i + " " + channel + " " + 0); //clear all
    }

    var nbRepeat = nbSpks;
    if (nbSpks > 4)
        nbRepeat = nbSpks*2+1;
	
	tsk = new Task(repeat, this);
	tsk.interval = speed; // the interval between repetition
	tsk.repeat(nbRepeat); //how many times it repeats

	function repeat() {
        if (prevSpk >= 0)
			outlet (0, column + " " + prevSpk + " " + channel + " " + 0);
			
		if (cnt == nbRepeat-1)
			return;
		
		prevSpk = spkIdx;
		
		outlet (0, column + " " + spkIdx + " " + channel + " " + 1);
        
        if (direction == 0)
            spkIdx += (forward == 1) ? 2 : -1; // jump 2 forward, 1 backward
        else
            spkIdx += (forward == 1) ? -2 : 1; // jump 2 backward, 1 forward
        
        if (spkIdx >= nbSpks) {
            spkIdx = (spkIdx == nbSpks) ? 0 : 1;
	    	outlet (1, "bang");
		}
	
        else if (spkIdx < 0)
            spkIdx = nbSpks + spkIdx;
        
        forward = !forward;
		cnt++;
		
  }
	
}

function bang() {
	tsk.cancel();
}