outlets = 2;

var bangA = 0;
		
function list()
{
	var a = arrayfromargs(arguments);
	var spkIdx = a[0]; // From speaker to start from, first spk is 0
	var nbSpks = a[1];
	var channel = a[2];
	var column = a[3];
	var speed = a[4];
	var direction = a[5];
    
	var prevSpk = -1;
	var cnt = 0;

    // Clear
    for (var i = 0; i < nbSpks; i++){
        outlet (0, column + " " + i + " " + channel + " " + 0); //clear all
    }

    var nbRepeat = nbSpks*3+1;
	
	var tsk = new Task(repeat, this);
	tsk.interval = speed; // the interval between repetition
	tsk.repeat(nbRepeat); //how many times it repeats

	function repeat() {
        if (prevSpk >= 0)
			outlet (0, column + " " + prevSpk + " " + channel + " " + 0);
			
		if (cnt == nbRepeat-1) {
			outlet (1, "bang")
			return;
		}
		
		prevSpk = spkIdx;
		
		outlet (0, column + " " + spkIdx + " " + channel + " " + 1);
        
        if (direction == 0)
            spkIdx ++;
        else
            spkIdx--;
        
        if (spkIdx >= nbSpks) {
            spkIdx = 0;
			speed = Math.floor(speed/2);
            tsk.interval = speed;

        }
        else if (spkIdx < 0) {
            spkIdx = nbSpks-1;
			if (cnt > 1) {
				speed = Math.floor(speed/2);
            	tsk.interval = speed;
	
			}
		}
        
		cnt++;
		
  }
	
}

function bang() {
	tsk.cancel();
}